	PROGRAM Xtract
	PARAMETER(Nfish=2, NevMax=3000)
	CHARACTER*30 filename
	REAL*8 RArena, BL
	INTEGER Nt(NevMax),Nle(NevMax)
	IOP = 1
	filename = '2hemigr.dat'
	filename = '2zebraf.dat'
	Nlines = 0
	OPEN(2,file=filename)
	DO it=1,10000000
	  READ(2,*,end=7) Nevent
	  Nlines = Nlines + 1
	ENDDO
7	CLOSE(2)
	OPEN(2, FILE=filename)
	ievent = 1
	Nle = 0
	 Nt = 0
	DO i=1,Nlines
	  READ(2,*,END=8) ievt
	  IF(ievt.EQ.ievent) Nle(ievent) = Nle(ievent) + 1
	  IF(ievt.GT.ievent) THEN
	    ievent = ievent + 1
	    Nle(ievent) = Nle(ievent) + 1
	  ENDIF
	ENDDO
8	CLOSE(2)
	Nt = Nle/Nfish
	Ntmax = maxval(Nt)
	  Nd = 21
	Npsi = 61
	CALL XTR(Nevent,Nfish,Nlines,Nle,Nt,Ntmax,filename,Nd,Npsi,IOP)
	END

	SUBROUTINE XTR(Nevent,Nfish,Nlines,Nle,Nt,Ntmax,filename
     &							  ,Nd,Npsi,IOP)
	CHARACTER*30 filename
	INTEGER Nle(Nevent),Nt(Nevent)
	REAL*8  Deltat(Nevent,Nfish,Ntmax), RArena, BL, xm
	REAL*8      xx(Nevent,Nfish,Ntmax), x(Ntmax)
	REAL*8      yy(Nevent,Nfish,Ntmax), y(Ntmax)
	REAL*8       r(Nevent,Nfish,Ntmax)
	REAL*8      Vx(Nevent,Nfish,Ntmax)
	REAL*8      Vy(Nevent,Nfish,Ntmax)
	REAL*8       V(Nevent,Nfish,Ntmax)
	REAL*8     Phi(Nevent,Nfish,Ntmax), PhiP1, PI
	REAL*8    DPhi(Nevent,Nfish,Ntmax)
	REAL*8     dij(Nevent,Nfish,Ntmax,Nfish), dd(Nfish)
	REAL*8 Thetaij(Nevent,Nfish,Ntmax,Nfish)
	REAL*8   psiij(Nevent,Nfish,Ntmax,Nfish)
	REAL*8  q,q1,q2,q3,q4,q5, qx,qy
	REAL*8   PP(Nd,Npsi), dijmin,dijmax, psiijmin,psiijmax
	INTEGER eps(Nd,Npsi),epstot
	REAL*8 fR(Nd),gR(Npsi), fRepu,gRepu
	PI = DACOS(-1.D0)
	CALL SRAND(-94187951)
	IF(filename.EQ.'2hemigr.dat') THEN
	  BL = 0.03D0
	  RArena = 0.250D0
	ENDIF
	IF(filename.EQ.'2zebraf.dat') THEN
	  BL = 0.045D0
	  RArena = 0.29D0
	ENDIF
	  dijmin = 0.D0
	  dijmax = 1.2D0*RArena
	psiijmin = - PI + 1.D-8
	psiijmax = - psiijmin
	WRITE(*,*) ' filename: ',filename
	IF(IOP.EQ.1) WRITE(*,*) 'OPTION: analytical & homogeneous '
	IF(IOP.EQ.2) WRITE(*,*) 'OPTION: analytical & real distr.'
	IF(IOP.EQ.3) WRITE(*,*) 'OPTION: from experimental data'
	WRITE(*,'(A8,1x,I2)')   '  #fish:',Nfish
	WRITE(*,'(A8,1x,F5.3)') '  BL(m):',BL
	WRITE(*,'(A8,1x,F5.3)') '  Arena:',RArena
	WRITE(*,'(A14,1x,I8)')  ' total #lines:',Nlines
	WRITE(*,*) '#lines per event (NOT SHOWN)'
	WRITE(*,*) '& time length (= #lines/Nfish)'
	Nltot = 0
	DO iev=1,Nevent
	  Nltot = Nltot + Nle(iev)
	ENDDO
	WRITE(*,'(A17,I4,2x,I7)') '#events & lines: ',Nevent,Nlines
	WRITE(*,'(A22,I7)') '#lines longest event: ',Ntmax
	WRITE(*,*)
	Deltat = 0.5D0
	OPEN(2,FILE=filename)
	DO ievent = 1,Nevent
	  DO ifish = 1,Nfish
	    DO it=1,Nt(ievent)
	      READ(2,*) ievt, ipd, Deltat(ievent,ifish,it)
     &		 ,xx(ievent,ifish,it),yy(ievent,ifish,it)
	      IF(ievt.NE.ievent.OR.ipd.NE.ifish) THEN
		WRITE(*,*) '----> problem:'
		WRITE(*,*) it,'event: ',ievt,ievent
		WRITE(*,*)' or '
		WRITE(*,*) it,'  ifish: ',ipd,ifish
		WRITE(*,*) 'Nt(ievent): ',Nt(ievent)
		WRITE(*,*) 'Ctrl-C, or enter 0 to continue'
		READ(*,*) q
	      ENDIF
	    ENDDO
	  ENDDO
	  WRITE(*,9999,ADVANCE='NO') CHAR(13), ievent,'-th event read'
	ENDDO
	CLOSE(2)
	WRITE(*,*) '--> Entire file read'
	DO iev = 1,Nevent
	  DO ifish = 1,Nfish
	    DO it=1,Nt(iev)-1
	      Deltat(iev,ifish,it) = 
     &	      Deltat(iev,ifish,it+1) - Deltat(iev,ifish,it)
	    ENDDO
	    Deltat(iev,ifish,Nt(iev)) = 0.5D0 
	  ENDDO
	ENDDO
	WRITE(*,*) 'Calculate quantities: r, V, Phi, d_ij, psi_ij...'
	DO iev = 1,Nevent
	  itini = 1
	  itend = Nt(iev)-1
	  DO ifish = 1,Nfish
	    x = 0.D0
	    y = 0.D0
	    DO it = itini,itend
	      x(it) = xx(iev,ifish,it)
	      y(it) = yy(iev,ifish,it)
	    ENDDO  
	    DO it = itini,itend
	       r(iev,ifish,it) = DSQRT(x(it)**2 + y(it)**2)
	      Vx(iev,ifish,it) = (x(it) - x(it-1))/Deltat(iev,ifish,it-1)
	      Vy(iev,ifish,it) = (y(it) - y(it-1))/Deltat(iev,ifish,it-1)
	       V(iev,ifish,it) = DSQRT(Vx(iev,ifish,it)**2
     &				    + Vy(iev,ifish,it)**2)
	      q1 = ATAN2(y(it)   - y(it-1),x(it)   - x(it-1))
	      q2 = ATAN2(y(it+1) - y(it)  ,x(it+1) - x(it))
	      Phi(iev,ifish,it) = q1
	      PhiP1             = q2
 	      q = PhiP1 - Phi(iev,ifish,it)
101	      IF(q.LT.-PI) q = q + 2.D0*PI
	      IF(q.GT. PI) q = q - 2.D0*PI
	      IF(DABS(q).GT.PI) GOTO 101
	      DPhi(iev,ifish,it) = q
	    ENDDO
	  ENDDO
	  DO ifish = 1,Nfish
	    DO it = itini,itend
	      DO jfish = 1,Nfish
		q = DSQRT( (xx(iev,ifish,it) - xx(iev,jfish,it) )**2
     &			 + (yy(iev,ifish,it) - yy(iev,jfish,it) )**2)
		dij(iev,ifish,it,jfish) = max(q,1.D-4)
		Thetaij(iev,ifish,it,jfish) =
     &			ATAN2( yy(iev,jfish,it) -  yy(iev,ifish,it)
     &			      ,xx(iev,jfish,it) -  xx(iev,ifish,it))
		q = Thetaij(iev,ifish,it,jfish) - Phi(iev,ifish,it)
		psiij(iev,ifish,it,jfish) = q
		IF(q.LT.-PI) psiij(iev,ifish,it,jfish) = q + 2.D0*PI
		IF(q.GT. PI) psiij(iev,ifish,it,jfish) = q - 2.D0*PI
	      ENDDO
	    ENDDO
	  ENDDO
	ENDDO

	WRITE(*,*) 'Filling the boxes:'
	NN = Nd*Npsi
	WRITE(*,*) '---> #boxes: Nd*Npsi = ',NN
	eps = 0   
	PP  = 0.D0
	ijoumeni = 0
	DO iev=1,Nevent
	  DO ifish=1,1
	    DO it=1,Nt(iev)
		ijoumeni = ijoumeni + 1
	      q4 =   dij(iev,ifish,it,3-ifish)
	      q5 = psiij(iev,ifish,it,3-ifish)
	      IF(    q4.GT.dijmin  .AND.q4.LT.dijmax
     &	        .AND.q5.GT.psiijmin.AND.q5.LT.psiijmax) THEN
		q1 =   dijmax -   dijmin + 1.D-14
		q2 = psiijmax - psiijmin
		id   = INT((q4 -   dijmin)*  Nd/q1) + 1
		ipsi = INT((q5 - psiijmin)*Npsi/q2) + 1
	        IF(ipsi.LT.1.OR.ipsi.GT.Npsi.OR.id.LT.1.OR.id.GT.Nd)
     &	        THEN
		  WRITE(*,'(" Bad index:",6I4)') id,ipsi
		  WRITE(*,'("Max values:",6I4)') Nd,Npsi
		  WRITE(*,*) 'Type 0 to continue or Ctrl C to stop'
		  READ(*,*) q
		ENDIF
		eps(id,ipsi) = eps(id,ipsi) + 1
	         PP(id,ipsi) =  PP(id,ipsi) + DPhi(iev,ifish,it)
	      ELSE
		NoValeVel = NoValeVel + 1
	      ENDIF
	    ENDDO
	  ENDDO
	ENDDO
	WRITE(*,'(" Number of times = Nlines/Nfish = ",I6)'), ijoumeni
	ivide = 0
	epstot = 0
	DO id  =1,Nd
	DO ipsi=1,Npsi
	  IF(eps(id,ipsi).GT.0) THEN
	         epstot = epstot + eps(id,ipsi)
	    PP(id,ipsi) = PP(id,ipsi)/eps(id,ipsi)
	  ELSE
	    ivide = ivide + 1
	  ENDIF  
	ENDDO
	ENDDO
	IF(IOP.LT.3) THEN
	  PP = 0.D0
	  epstot = 0
	  DO id  =1,Nd
	  DO ipsi=1,Npsi
	    q1 = (id-0.5D0)*(dijmax - dijmin)/Nd + dijmin
	    q2 = (ipsi-0.5D0)*2.D0*PI/Npsi - PI
	    ndats = eps(id,ipsi)
	    IF(IOP.EQ.1) ndats = 1
	    DO l=1,ndats
	      epstot = epstot + 1
	      PP(id,ipsi) = PP(id,ipsi) 
     &		+ fRepu(q1,RArena)*gRepu(q2)
     &	       	+ 0.7D0*(rand(0)-0.5D0)
	    ENDDO
	    IF(eps(id,ipsi).GT.0) PP(id,ipsi)=PP(id,ipsi)/ndats
	    IF(IOP.EQ.1) THEN
	      ivide = 0
	      NoValeVel = 0
	    ENDIF
	  ENDDO
	  ENDDO
	  IF(IOP.EQ.1) eps = 1
	ENDIF  
	WRITE(*,'(" Boxes filled (empty): ",I6," (",I6,"), over ",I7)')
     &	  Nd*Npsi-ivide, ivide, Nd*Npsi
	WRITE(*,'("  Data placed  (lost): ",I6," (",I6,"), over ",I7)')
     &		epstot,NoValeVel,Nlines/Nfish
	CALL ITERS(Nd,Npsi,PP,eps,dijmin,dijmax,fR,gR)
	WRITE(*,*) 'Write the data from the analytical expressions'
	OPEN(702,file='00.fR-analytic.dat')
	OPEN(703,file='00.gR-analytic.dat')
	DO id=1,101
	  xm = (id-0.5D0)*2.D0*RArena/101.D0
	  WRITE(702,*) xm,fRepu(xm,RArena)
	ENDDO
	DO ipsi=1,101
	  xm = (ipsi-0.5D0)*2.D0*PI/101.D0 - PI
	  WRITE(703,*) xm,gRepu(xm)
	ENDDO
	CLOSE(702)
	CLOSE(703)
999	FORMAT(I6,2x,F10.4,1x,I7,5(1x,F10.4))
9999	FORMAT(A1,1x,I5,A15)
	END
	FUNCTION fRepu(d,RArena)
	REAL*8   fRepu,d,RArena, gammaAtt, datt, latt
	gammaAtt = 4.D0
	datt = 0.03D0
	latt = 0.2D0
	fRepu = gammaAtt*(d-datt)/(1.D0+(d/latt)**2)
	IF (d.GT.0.35D0) fRepu = 0.D0
	
	fRepu = dexp(-(d/0.1D0)**2)
	
	RETURN
	END
	FUNCTION gRepu(psi)
	REAL*8   gRepu,psi,x, a0,a1,a2
	x = psi
	gRepu = 1.395D0*DSIN(x)*(1.D0 - 0.33D0*DCOS(x))
	
	gRepu = DSQRT(2.D0)*DSIN(x)
	
	RETURN
	END
	SUBROUTINE ITERS(Nd,Npsi,PP,eps,dijmin,dijmax,fR,gR)
	REAL*8 PP(Nd,Npsi), MR(Nd,Npsi)
	INTEGER eps(Nd,Npsi), epstot, eeps
	REAL*8 fR(Nd),gR(Npsi), fR0(Nd),gR0(Npsi)
	REAL*8 dij(Nd),psiij(Npsi), dijmin,dijmax, fghR
	REAL*8 fRepu,gRepu
	REAL*8 lambda, TOL, PI, x, xm,  q,q1,q2,q3,q4
	REAL*8 sumfR, sumgR, NumfR, NumgR, DenomfR, DenomgR 
	REAL*8 DELTA, DELTAOld
	REAL*8 errfR,errgR
	PI = DACOS(-1.D0)
	lambda = 0.025D0
	TOL = 1.D-9	
	Nit = 50000	
	fR = 0.D0
	gR = 0.D0
	DELTA = 0.D0
	DO id=1,Nd
	  dij(id) = (id-0.5D0)*(dijmax - dijmin)/Nd + dijmin
	ENDDO
	DO ipsi=1,Npsi
	  psiij(ipsi) = (ipsi-0.5D0)*2.D0*PI/Npsi - PI
	ENDDO
	DO id=1,Nd
	  fR0(id) = 1.D0
	ENDDO
	DO ipsi=1,Npsi
	  gR0(ipsi) = 1.D0
	ENDDO
	OPEN(202,file='01.fR-iters.dat')
	OPEN(203,file='01.gR-iters.dat')
	DO id=1,Nd
	  WRITE(202,'(I7,3(2X,F18.6))') 0,dij(id),fR0(id)
	ENDDO  
	WRITE(202,*) 
	DO ipsi=1,Npsi
	  WRITE(203,'(I7,3(2X,F18.6))') 0,psiij(ipsi),gR0(ipsi)
	ENDDO  
	WRITE(203,*) 
	WRITE(*,*)
	WRITE(*,*)'-R E C O N S T R U C T I O N   I T E R A T I O N S-'
	WRITE(*,'(A26,1x,E8.2)') '  DELTA minimization: TOL=',TOL
	DO 1 it=1,Nit
	  DO id  =1,Nd
	  DO ipsi=1,Npsi
	    MR(id,ipsi) = PP(id,ipsi)
	  ENDDO
	  ENDDO
	  DO id=1,Nd
	      NumfR = 0.D0
	    DenomfR = 0.D0
	    DO ipsi=1,Npsi
	        NumfR =   NumfR + eps(id,ipsi) * gR0(ipsi)*MR(id,ipsi)
	      DenomfR = DenomfR + eps(id,ipsi) * gR0(ipsi)**2
	    ENDDO
	    fR(id) = fR0(id)
	    IF(DenomfR.GT.0.D0) fR(id) = NumfR/DenomfR
	  ENDDO
	  DO ipsi=1,Npsi
	      NumgR = 0.D0
	    DenomgR = 0.D0
	    DO id  =1,Nd
	        NumgR =   NumgR + eps(id,ipsi) * fR0(id)*MR(id,ipsi)
	      DenomgR = DenomgR + eps(id,ipsi) * fR0(id)**2
	    ENDDO
	    gR(ipsi) = gR0(ipsi)
	    IF(DenomgR.GT.0.D0) gR(ipsi) = NumgR/DenomgR
	  ENDDO
	  fR0 = (1.D0-lambda)*fR0 + lambda*fR
	  gR0 = (1.D0-lambda)*gR0 + lambda*gR
	  sumgR = 0.D0
	  DO ipsi=1,Npsi
	    sumgR = sumgR + gR0(ipsi)**2/Npsi
	  ENDDO
	  IF(sumgR.GT.1.D-4) THEN
	    gR0 = gR0/DSQRT(sumgR)
	    fR0 = fR0*DSQRT(sumgR)
	  ELSE
	    WRITE(*,*)'problem: integral of g^2 is zero'
	    WRITE(*,'(5(F5.2,1x))') sumgR
	    WRITE(*,*)'Type Ctrl C to stop'
	    READ(*,*) q
	  ENDIF
	  IF(it/3*3.EQ.it) THEN
	    DO id=1,Nd
	      WRITE(202,'(I7,3(2X,F18.6))') it,dij(id),fR0(id)
	    ENDDO  
	    WRITE(202,*)  
	    DO ipsi=1,Npsi
	      WRITE(203,'(I7,3(2X,F18.6))') it,psiij(ipsi),gR0(ipsi)
	    ENDDO  
	    WRITE(203,*)  
	    DELTAold = DELTA
	    DELTA = 0.D0
	    DO id  =1,Nd
	      DO ipsi=1,Npsi
	        q = PP(id,ipsi) - fR0(id)*gR0(ipsi)
	        DELTA = DELTA + eps(id,ipsi)*q**2
	      ENDDO
	    ENDDO
	    NN = Nd*Npsi
	    IF(DABS(DELTA - DELTAold).LT.TOL*NN) GOTO 123
	    WRITE(*,99, ADVANCE='NO') CHAR(13),it,' DELTA = ',DELTA/NN
	  ENDIF 
1	CONTINUE 
123	CLOSE(202)
	CLOSE(203)
	fR = fR0
	gR = gR0
	WRITE(*,*)
	OPEN(302,file='02.fR-end.dat')
	OPEN(303,file='02.gR-end.dat')
	    DO id=1,Nd
	      WRITE(302,'(3(2X,F18.6))') dij(id),fR(id)
	    ENDDO  
	    DO ipsi=1,Npsi
	      WRITE(303,'(3(2X,F18.6))') psiij(ipsi),gR(ipsi)
	    ENDDO  
	CLOSE(302)
	CLOSE(303)
	WRITE(*,*) 'Errors: l_2 norm of relative error'
	WRITE(*,*) "[1/N sum_{i=1}^N e_i^2 ]^(1/2), e_i = x_i/x'_i - 1"
	OPEN(301,file='02.fR-end.dat')
	errfR = 0.D0
	DO id=1,Nd
	  READ(301,*) q,q2
	  IF(DABS(q2).GT.1.D-1)
     &		  errfR = errfR + (fRepu(q,0.25D0)/q2-1.D0)**2
	ENDDO
	errfR = DSQRT(errfR/Nd)
	WRITE(*,'(A8,F12.6)') '   f(d):',errfR
	CLOSE(301)
	OPEN(301,file='02.gR-end.dat')
	errgR = 0.D0
	DO ipsi=1,Npsi
	  READ(301,*) q,q2
	  IF(DABS(q2).GT.1.D-1) errgR = errgR+(gRepu(q)/q2-1.D0)**2
	ENDDO
	errgR = DSQRT(errgR/Npsi)
	WRITE(*,'(A8,F12.6)') ' g(psi):',errgR
	CLOSE(301)
99	FORMAT(A1,I6,1x,A8,3(1x,F18.12),1x,A9,6(1x,F5.2))	
	RETURN
	END
